Subject: Re: [RFC PATCH V2] tcp: introduce raw access to experimental options

From: Einar Lueck <[email-masked]>
Date: Tue, 08 Jan 2013 15:36:35 +0100

On 01/07/2013 05:44 PM, Eric Dumazet wrote:
>
> Thats a big addition, and for example doesn't help if the SYNACK should
> include an option that is depending on the content of SYN message.
>
> For TCP fastopen for example, the cookie we send to the client is not a
> constant cookie.
>
> Also TCP coalescing of TCP collapse will merge several skbs, so storing
> "the last received options" in the socket is kind of not well defined
> semantic.
>
> It looks like you need to add hooks and kernel modules to fully use
> experimental options, like congestion control modules.
>
>
Thanks for the fast feedback, Eric. Let me try to make sure that I
understand your suggestions correctly:
You suggest to have a set of hooks that allow to move all code that
exploits experimental options into dedicated modules (e.g. one module
for TCP fastopen and one for cookies). Extensibility then comes on
a per module granularity. Is my understanding correct?

Thx,
Einar.